/*************************************************
*
*     PROJECT: Rounded SLE
*  Programmer: J.A. Diego Kerejeta
*     Created: June 20, 2019
*
*     Version: 0.1
*
**************************************************/
#include 'Appevent.ch'
#include 'Common.ch'
#include 'Gra.ch'
#include 'Xbp.ch'
#include 'Font.ch'
#include 'MyStd.ch'

#define xbeP_Fin                 xbeP_User + 1

#define TIT_TESTS     'Test'
#define TXT_TEST_1    'Rounded SLE'
#define TXT_MENU      'Menu'
#define TXT_QUIT      'Quit '


*************************
PROCEDURE DbeSys ; RETURN
*************************

****************
PROCEDURE AppSys
****************
LOCAL oDlg

oDlg := XbpDialog():new( , , { 0, 0 }, { 790, 600 }, , .F. )
   oDlg:taskList                := .T.
   oDlg:close                   := {|u1, u2, obj| PostAppEvent( xbeP_Fin,,, obj ) }
   oDlg:border                  := XBPDLG_DLGBORDER
   oDlg:title                   := TIT_TESTS
   oDlg:drawingArea:clipChildren:= .T.
   oDlg:create()
   AppMenu( oDlg:menuBar() )
   oDlg:setFrameState( XBPDLG_FRAMESTAT_MAXIMIZED )

SetAppFocus( oDlg )
SetAppWindow( oDlg )
RETURN

*****************************
PROCEDURE AppMenu( oMenuBar )
*****************************
LOCAL oMenu

oMenu:= XbpMenu():new( oMenuBar )
   oMenu:title := TXT_MENU
   oMenu:create()
   oMenu:addItem( { TXT_TEST_1,  {|| Sample( SetAppWindow() ) } } )

   oMenu:addItem( { NIL, NIL, XBPMENUBAR_MIS_SEPARATOR, 0} )
   oMenu:addItem( { TXT_QUIT,  {|| PostAppEvent( xbeP_Fin ) } } )
   oMenuBar:addItem( { oMenu, } )
RETURN

**************
PROCEDURE Main
**************
LOCAL nEvent, mp1, mp2, oXbp

DO WHILE nEvent <> xbeP_Fin
   nEvent := AppEvent( @mp1, @mp2, @oXbp )
   oXbp:handleEvent( nEvent, mp1, mp2 )
ENDDO
QUIT
RETURN

*****************************
PROCEDURE Sample( oDlgOwner )
*****************************
LOCAL nEvent, mp1, mp2, oDlg, oXbp, oFocus
LOCAL aSize:= { 710, 570 }
LOCAL aPos := { Int( ( AppDesktop():currentSize()[ 1 ] - aSize[ 1 ] ) / 2 ), ;
                Int( ( AppDesktop():currentSize()[ 2 ] - aSize[ 2 ] ) / 2 ) }

oDlg := XbpDialog():new( AppDesktop(), oDlgOwner, aPos, aSize, { { XBP_PP_ORIGIN, XBP_ORIGIN_TOPLEFT }, ;
                         { XBP_PP_COMPOUNDNAME,  '9.Arial' } }, .F. )
   oDlg:title                   := TXT_TEST_1
   oDlg:taskList                := .T.
   oDlg:drawingArea:clipChildren:= .T.
   oDlg:create()

oXbp := RoundSle():new()
   oXbp:tabStop  := .T.
   oXbp:cueBanner:= 'Custom RoundSle #1'
   oXbp:create( oDlg:drawingArea,, { 10, 30 }, { 200, 28 }, { { XBP_PP_ORIGIN, XBP_ORIGIN_TOPLEFT } } )

oXbp := RoundSle():new()
   oXbp:tabStop  := .T.
   oXbp:cueBanner:= 'Custom RoundSle #2'
   oXbp:create( oDlg:drawingArea,, { 10, 70 }, { 200, 28 }, { { XBP_PP_ORIGIN, XBP_ORIGIN_TOPLEFT } } )

oXbp := RoundSle():new()
   oXbp:tabStop  := .T.
   oXbp:cueBanner:= 'Custom RoundSle #3'
   oXbp:nRadius  := 19
   oXbp:nIcon    := ICON_SEARCH
   oXbp:nIconSize:= 16
   oXbp:border   := .F.
   oXbp:create( oDlg:drawingArea,, { 10, 110 }, { 200, 28 }, { { XBP_PP_ORIGIN, XBP_ORIGIN_TOPLEFT } } )

oXbp := XbpSle():new()
   oXbp:tabStop  := .T.
   oXbp:cueBanner:= 'Normal XbpSle #1'
   oXbp:create( oDlg:drawingArea,, { 10, 150 }, { 200, 28 }, { { XBP_PP_ORIGIN, XBP_ORIGIN_TOPLEFT } } )

oXbp := RoundSle():new()
   oXbp:tabStop  := .T.
   oXbp:cueBanner:= 'Custom RoundSle #4'
   oXbp:nRadius  := 0
   oXbp:nIcon    := ICON_SEARCH
   oXbp:nIconSize:= 16
   oXbp:create( oDlg:drawingArea,, { 250, 30 }, { 200, 28 }, { { XBP_PP_ORIGIN, XBP_ORIGIN_TOPLEFT } } )

oXbp := RoundSle():new()
   oXbp:tabStop  := .T.
   oXbp:cueBanner:= 'Custom RoundSle #5'
   oXbp:nRadius  := 19
   oXbp:nIcon    := ICON_SEARCH
   oXbp:nIconSize:= 16
   oXbp:create( oDlg:drawingArea,, { 250, 70 }, { 200, 28 }, { { XBP_PP_ORIGIN, XBP_ORIGIN_TOPLEFT } } )

oXbp := RoundSle():new()
   oXbp:tabStop  := .T.
   oXbp:cueBanner:= 'Custom RoundSle #6'
   oXbp:nRadius  := 19
   oXbp:nIcon    := ICON_SEARCH
   oXbp:nIconSize:= 16
   oXbp:create( oDlg:drawingArea,, { 250, 110 }, { 200, 28 }, { { XBP_PP_ORIGIN, XBP_ORIGIN_TOPLEFT } } ):disable()

oXbp := RoundSle():new()
   oXbp:tabStop   := .T.
   oXbp:cueBanner:= 'Custom RoundSle #7'
   oXbp:create( oDlg:drawingArea,, { 250, 150 }, { 200, 28 }, { { XBP_PP_ORIGIN, XBP_ORIGIN_TOPLEFT } } ):disable()

oXbp := XbpSle():new()
   oXbp:tabStop  := .T.
   oXbp:cueBanner:= 'Normal XbpSle #2'
   oXbp:create( oDlg:drawingArea,, { 250, 190 }, { 200, 28 }, { { XBP_PP_ORIGIN, XBP_ORIGIN_TOPLEFT } } ):disable()

oDlg:setModalState( XBP_DISP_APPMODAL )
oDlg:show()
oFocus:= SetAppFocus( oDlg:drawingArea:childList()[ 1 ] )

DO WHILE nEvent <> xbeP_Close
   nEvent := AppEvent( @mp1, @mp2, @oXbp )
   oXbp:handleEvent( nEvent, mp1, mp2 )
ENDDO
oDlg:setModalState( XBP_DISP_MODELESS )
oDlg:destroy()
SetAppFocus( oFocus )
RETURN

